using System;

namespace ConsoleDbApplication
{

  /* eksempel p direkte databasetilgang for C# med DataReader */
	public class VareDbAccess
	{
    private System.Data.IDbConnection con;    /* connection */
    private System.Data.IDbCommand cmd;       /* command    */
   
    public VareDbAccess()
		{
      OpenMySqlVare ();
      VisVarer();
      IndstVarer();
      RetVare (1);
      VisVarer();
      con.Close();

      OpenAccessVare ();
      VisVarer();
      RetVare (1);
      VisVarer();
      con.Close();
    }

    public void OpenAccessVare ()
    {
      string connectionName = "Provider=Microsoft.Jet.OLEDB.4.0;"
                              +"Data Source=Varesystem.mdb;"
                              +"Jet OLEDB:Database Password=bjbu;"; 
      con = new System.Data.OleDb.OleDbConnection(connectionName);                        
      con.Open();
      cmd = con.CreateCommand();
    }

    public void OpenMySqlVare ()
    {
      string connectionName = "Database=Varesystem;"
                              +"Data Source=localhost;" /*127.0.0.1;" /* localhost */
                              +"User Id=root;"
                              +"Password=bjbu";
      con = new MySql.Data.MySqlClient.MySqlConnection(connectionName);                        
      con.Open();
      cmd = con.CreateCommand();
    }
    
    public void VisVarer ()
    { // Precond: con og cmd skal vre etaberet og open
      System.Data.IDataReader dataReader; 
      cmd.CommandText = "SELECT * FROM Vare";
      dataReader = cmd.ExecuteReader();
      while ( dataReader.Read() )
      {
        Console.WriteLine("Nr:"+ dataReader["Varenr"]
                          +" " +   dataReader["Betegnelse"]
                          +" AntalPLager:"+dataReader["AntalPaaLager"]
                          +" Salgs Enheds Pris:"+dataReader["SalgsEnhedsPris"] );
      }
      dataReader.Close(); /* luk foresprsel*/
      Console.ReadLine(); /* vent p retur */
    }

    public void RetVare (int id)
    { // Precond: con og cmd skal vre etaberet og open
      //          der m ikke vre bne foresprgsler
      int antalRettet;
      cmd.CommandText = "UPDATE Vare SET"
                        +" AntalPaaLager=AntalPaaLager+1"
                        +" WHERE ID="+id;
      antalRettet = cmd.ExecuteNonQuery(); /* udfr SQL Update/Insert/Delete  */
      Console.WriteLine("Antal rettet:"+antalRettet);
    }

    public void SletVare (int id)
    { // Precond: con og cmd skal vre etaberet og open
      //          der m ikke vre bne foresprgsler
      int antalSlettet;
      cmd.CommandText = "DELETE FROM Vare "
                        +" WHERE ID="+id;
      antalSlettet = cmd.ExecuteNonQuery(); /* udfr SQL Update/Insert/Delete  */
      Console.WriteLine("Antal slettet:"+antalSlettet);
    }
    public void IndstVarer ()
    { // Precond: con og cmd skal vre etaberet og open
      //          der m ikke vre bne foresprgsler
      int antalIndsat;
      cmd.CommandText = "INSERT INTO Vare "
               + " (Varenr, Betegnelse, AntalPaaLager, SalgsEnhedsPris)"
               + " VALUES"
               + " (1001,'A4 blok ternet med huller',0,3.98)";
      antalIndsat = cmd.ExecuteNonQuery(); /* udfr SQL Update/Insert/Delete  */
      Console.WriteLine("Antal indsat:"+antalIndsat);
    }
  }
}
